/*
 * Copyright (c) 2005 SilverStorm Technologies.  All rights reserved.
 * Copyright (c) 1996-2003 Intel Corporation. All rights reserved. 
 * Portions Copyright (c) 2008 Microsoft Corporation.  All rights reserved.
 *
 * This software is available to you under the OpenIB.org BSD license
 * below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 * $Id: al_proxy.h 33 2005-07-11 19:51:17Z ftillier $
 */

/*
 * Abstract:
 *	This header file defines data structures for the kernel-mode NDI support 
 *
 * Environment:
 *	Kernel .
 */


#ifndef _AL_NDI_CQ_H_
#define _AL_NDI_CQ_H_

void
ndi_cq_flush_ques(
	IN				ib_cq_handle_t				h_cq );

NTSTATUS
ndi_cq_init(
	IN				ib_cq_handle_t				h_cq );

void 
ndi_cq_compl_cb(
	IN		const	ib_cq_handle_t				h_cq,
	IN				void						*cq_context );

void 
ndi_cq_error_cb(
	IN				ib_async_event_rec_t		*p_err_rec );

#endif
